#!/usr/local/bin/perl

#use CGI::Carp qw(fatalsToBrowser);

#use LWP::UserAgent;
use LWP::RobotUA;

$BASE_DIR = "users/";
$BASE_DIR_CACHE = "/home/motreja/www/ankur/webdrill/cache/";

$user = $ENV{"REMOTE_USER"};
$BASE_CACHE_USER = "${BASE_DIR_CACHE}${user}/";

# Read query string and store in $Form. Also set $type depending on the method
if($ENV{'REQUEST_METHOD'} eq "POST") {
  $type = "data_received";
  read(STDIN, $QueryString, $ENV{'CONTENT_LENGTH'});
} else {
  $type = "display_form";
  $QueryString = $ENV{QUERY_STRING};
}

$user = $ENV{"REMOTE_USER"};
$BASE_DIR = "${BASE_DIR}${user}/";

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

# Split the path for the current category
@category_list = split (/\//, $Form{path});

$Form{path} =~ tr/+/ /;

# Read the global config file into Config_global
&parse_config_file ("$BASE_DIR$category_list[0].config", \%Config_global);

# Read the local config file into Config_local
&parse_config_file ("$BASE_DIR$Form{path}\/config", \%Config_local);

if ( $type eq "display_form" ) {

# Display the form to add a new entry
  print "Content-type: text/html", "\n\n";
  print "<html><body>";
  print "<FORM ACTION=\"add_entry.pl\" METHOD=\"POST\">";

  print "<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"$Form{\"path\"}\">";

  $i = 0;
  while ( $Config_global{"${i}_key"} ne "" ) {

    if ($Config_global{"${i}_input"} ne "") {
        $value_of_field = eval "$Config_global{\"${i}_input\"}";
    } else {
        $value_of_field = "";
    }

    print "<BR><B>$Config_global{\"${i}_name\"} :</B> <BR>$Config_global{\"${i}_comment\"}<BR>";

    if ( $Config_global{"${i}_type"} eq "textarea") {
        @size_list = split (/x/, $Config_global{"${i}_size"});
        print "<TEXTAREA NAME=\"$Config_global{\"${i}_key\"}\" ROWS=\"$size_list[0]\" COLS=\"$size_list[1]\">$value_of_field</TEXTAREA><BR>";
    } elsif ( $Config_global{"${i}_type"} eq "text") {
        print "<INPUT TYPE=\"text\" SIZE=\"$Config_global{\"${i}_size\"}\" NAME=\"$Config_global{\"${i}_key\"}\" VALUE=\"$value_of_field\"><BR>";
    } elsif ( $Config_global{"${i}_type"} eq "radio") {
        for ($l=1; $l <= $Config_global{"${i}_num_of_options"}; $l++) {
            $temp = $Config_global{"${i}_option_${l}"};
            if ($Config_global{"${i}_checked"} eq $l) {
                print "<INPUT TYPE=\"radio\" NAME=\"$Config_global{\"${i}_key\"}\" VALUE=\"$temp\" CHECKED>$temp<BR>";
            } else {
                print "<INPUT TYPE=\"radio\" NAME=\"$Config_global{\"${i}_key\"}\" VALUE=\"$temp\">$temp<BR>";
            }
        }
    } elsif ( $Config_global{"${i}_type"} eq "none") {
        print "$value_of_field<BR>";
        print "<INPUT TYPE=\"hidden\" NAME=\"$Config_global{\"${i}_key\"}\" VALUE=\"$value_of_field\">";
    }
    $i++;
  }

  print "<BR><INPUT TYPE=\"submit\" NAME=\"Submit\" VALUE=\"Submit\">";

} elsif ( $type eq "data_received" ) {

# Lock the category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &lock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to lock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to lock the category $Form{path}.";
    exit(0);
  }


# Open the database and find an unused key
  dbmopen %ENTRIES, "$BASE_DIR$Form{path}\/entries", 0666;

  $found_usable_key = 0;
  $new_key = 0;

  while ($found_usable_key == 0) {

    $temp = $ENTRIES{"${new_key}_USED"};

    if ($temp eq "") {
        $found_usable_key = 1;
    } else {
        $new_key++;
    }
  }

$rec_name = $Form{"name"};
$rec_url = $Form{"url"};
$dest_file = "${BASE_CACHE_USER}${rec_name}.htm";
if ( &get_page("$rec_url","$dest_file") == 0 ) {

    exit(0);

}

# Put each entry into the database with the key as the new key generated concantenated with the key got from the form, seperated by an _
  foreach $Form_key (keys %Form) {
      if ( ($Form_key ne "path") && ($Form_key ne "Submit") ) {
          $ENTRIES_key = "${new_key}_$Form_key";
          $ENTRIES{"$ENTRIES_key"} = $Form{"$Form_key"};
      }
  }

  $ENTRIES{"${new_key}_USED"} = 1;

  if ( ($ENTRIES{"LARGEST_KEY"} eq "") || ($new_key > $ENTRIES{"LARGEST_KEY"}) ) {
      $ENTRIES{"LARGEST_KEY"} = $new_key;
  }

  dbmclose %ENTRIES;


# Unlock the category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &unlock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to unlock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to unlock the category $Form{path}.";
    exit(0);
  }

# Display the category
  $the_path = $Form{path};
  $the_path =~ tr/ /+/;
  print "Location: display.pl?path=$the_path", "\n\n";

}

# Subroutine to unlock the category
sub unlock {

  ($_) = @_;

  $output = `rm \"$_\/lock\"`;
  if (open(LOCK, "$_\/lock")) {
    close(LOCK);
    return 0;
  }

  return 1;
}

# Subroutine to lock the category
sub lock {

  ($_) = @_;

  if (open(LOCK, "$_\/lock")) {
    $time_of_lock = <LOCK>;
    $time = time();
    if ($time - $time_of_lock < 900) {
      close(LOCK);
      return 0;
    }
    close(LOCK);
  }

  open(LOCK, ">$_\/lock");

  $time = time();
  print LOCK "$time";

  close(LOCK);

  return 1;

}



#subroutine to parse a config file and store it as a hash.
#Takes 2 arguments - the config file and a reference to the hash

sub parse_config_file {


local ($config_line, $Name, $Value, $Config);

$Config = $_[1];

if (!open (CONFIG, "$_[0]")) {
  print "Content-type: text/html", "\n\n";
  print "<html><body>";
  print "<B>ERROR</B><BR>Config file not found : $_[0].config";
  exit(0);
}

while (<CONFIG>) {
    $config_line=$_;
    chop ($config_line);
    $config_line =~ s/^\s*//;
    $config_line =~ s/\s*$//;
    if ( ($config_line !~ /^#/) && ($config_line ne "") ){
        ($Name, $Value) = split (/=/, $config_line);
        $$Config{$Name} = $Value;
    }
}

close(CONFIG);

}


sub lastupdated_input {

    $username = $_[0];
    $date_time = `date`;
    $return_line = "$username on $date_time";
    chop ($return_line);
    return "$return_line";

}


sub get_page {

    local ($url, $file, $ua, $date);

    $url = $_[0];
    $file = $_[1];

#    $ua = new LWP::UserAgent;
#    $ua = new LWP::UserAgent;
#    $ua->agent("WebDrill/1.0");

    $ua = LWP::RobotUA->new( 'WebDrill/1.0', 'ankur@motreja.com' );
    $ua->delay(10/60);

    $req = HTTP::Request->new("GET","$url");
    $res = $ua->request($req, "$file");

    if (!$res->is_success) {
        print "Content-type: text/html", "\n\n";
        print "<HTML><BODY>";
        print "Unable to get the url : $url<BR>The error returned was : " . $res->status_line . "<BR><BR>";
        print "Please mail webdrill\@motreja.com with the given url if you would like this to be looked into";
        return 0;
    }

    return 1;

}
