#!/usr/local/bin/perl

#use CGI::Carp qw(fatalsToBrowser);

#use LWP::UserAgent;
use LWP::RobotUA;

$BASE_DIR_DB = "/home/motreja/www/cgi-bin/webdrill/users/";

$BASE_DIR_CACHE = "/home/motreja/www/ankur/webdrill/cache/";
$BASE_DIR_SAVED = "/home/motreja/www/ankur/webdrill/saved/";

$date_time = `date`;
($day) = split (/ /, $date_time);
$log_file = "/home/motreja/www/cgi-bin/webdrill/data/log_$day.txt";

open(LOG_FILE, ">$log_file");
$send_log_mail = 0;

print LOG_FILE "===================================\n";
print LOG_FILE "www_lookup: Starting at $date_time\n";
print LOG_FILE "===================================\n\n";

print "Content-type: text/html", "\n\n";
print "<html><body>";

print LOG_FILE "www_lookup: Calling get_user_names\n";

&get_user_names ("/home/motreja/.htpasswds/cgi-bin/webdrill/passwd", \@usernames);

print LOG_FILE "www_lookup: get_user_names returned list of usernames : @usernames\n";

foreach $user (@usernames) {

    $mail_data = "";
    $mail_user = 0;
    $User_data = "";

    &parse_file ("/home/motreja/www/cgi-bin/webdrill/data/users/$user.dat", \%User_data);

    $mail_data = "Hi $User_data{\"NAME\"},\n\nThe following Webpage change(s) were found according to the criteria you specified:\n\n";

    $BASE_DB_USER = "${BASE_DIR_DB}${user}\/db\/";
    $BASE_CACHE_USER = "${BASE_DIR_CACHE}${user}/";
    $BASE_SAVED_USER = "${BASE_DIR_SAVED}${user}/";

    print LOG_FILE "\n--------------------------------------------\n";
    print LOG_FILE "www_lookup: processing for user $user\n";
    print LOG_FILE "BASE_DB_USER = $BASE_DB_USER\n";
    print LOG_FILE "BASE_CACHE_USER = $BASE_CACHE_USER\n";
    print LOG_FILE "BASE_SAVED_USER = $BASE_SAVED_USER\n\n";

    print LOG_FILE "www_lookup: Calling init_get_next_entry\n";

    &init_get_next_entry("${BASE_DB_USER}entries");

    print LOG_FILE "www_lookup: largest_entry = $largest_entry (after init_get_next_entry)\n\n";
    print LOG_FILE "www_lookup: Calling get_next_entry\n";

    while (&get_next_entry(\%Entry) == 1) {

        print LOG_FILE "\n\nwww_lookup: After get_next_entry :\n";
        print LOG_FILE "Entry{\"name\"} = $Entry{\"name\"}\n";
        print LOG_FILE "Entry{\"url\"} = $Entry{\"url\"}\n";
        print LOG_FILE "Entry{\"match_type\"} = $Entry{\"match_type\"}\n";
        print LOG_FILE "Entry{\"phrase\"} = $Entry{\"phrase\"}\n";
        print LOG_FILE "Entry{\"save\"} = $Entry{\"save\"}\n";
        print LOG_FILE "Entry{\"valid\"} = $Entry{\"valid\"}\n";

        $url = $Entry{"url"};

        print LOG_FILE "\nwww_lookup: Calling get_page\n";
        if ( &get_page("$url","/home/motreja/www/cgi-bin/webdrill/data/temp.htm") ) {

            $name = "$Entry{\"name\"}";

            $output = `ls \"${BASE_CACHE_USER}${name}.htm\"`;
            if ($output eq "") {
                print LOG_FILE "\nwww_lookup: ${BASE_CACHE_USER}${name}.htm not found. So, copying latest file there.\n";
                `cp \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\" \"${BASE_CACHE_USER}${name}.htm\"`;
            }

            if ($Entry{"match_type"} eq "Any change in the page") {
                $output = `/usr/bin/diff \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\" \"${BASE_CACHE_USER}${name}.htm\"`;

                print LOG_FILE "\nwww_lookup: diff arguments: \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\" \"${BASE_CACHE_USER}${name}.htm\"";
                print LOG_FILE "\nwww_lookup: match_type = Any change in the page. Output of diff = $output\n";
                print LOG_FILE "\nEND OF DIFF\n";

                if ($output ne "") {
                    $mail_user = 1;
                    print LOG_FILE "\nwww_lookup: diff shows change. To be mailed to $user\n";
                    $mail_data = "${mail_data}------------------------------\n";
                    $mail_data = "${mail_data}Name of the record : $Entry{\"name\"}\n";
                    $mail_data = "${mail_data}URL                : $Entry{\"url\"}\n";
                    $mail_data = "${mail_data}\nThe webpage has changed\n";
                    if ($Entry{"save"} eq "Yes") {
                        `cp \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\" \"${BASE_SAVED_USER}${name}.htm\"`;
                        $mail_data = "${mail_data}\nA local copy has been saved at http://motreja.com/ankur/webdrill/saved/ankur/${name}.htm\n";
                    } else {
                        print LOG_FILE "Entry{save} = $Entry{\"save\"} and not Yes";
                    }
                    $mail_data = "${mail_data}\n";
                }

            } elsif ($Entry{"match_type"} eq "Phrase appears on the page") {
                $phrase = $Entry{"phrase"};
                $output = `/bin/grep \"$phrase\" \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\"`;

                print LOG_FILE "\nwww_lookup: grep arguments: \"$phrase\" \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\"";
                print LOG_FILE "\nwww_lookup: match_type = Phrase appears on the page. Trying to match $phrase. Output of grep = $output\n";
                print LOG_FILE "\nEND OF GREP\n";

                if ($output ne "") {
                    $mail_user = 1;
                    print LOG_FILE "\nwww_lookup: grep shows phrase. To be mailed to $user\n";
                    $mail_data = "${mail_data}------------------------------\n";
                    $mail_data = "${mail_data}Name of the record : $Entry{\"name\"}\n";
                    $mail_data = "${mail_data}URL                : $Entry{\"url\"}\n";
                    $mail_data = "${mail_data}Phrase to look for : $Entry{\"phrase\"}\n";
                    $mail_data = "${mail_data}\nThe phrase you specified was found in the webpage\n";
                    if ($Entry{"save"} eq "Yes") {
                        `cp \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\" \"${BASE_SAVED_USER}${name}.htm\"`;
                        $mail_data = "${mail_data}\nA local copy has been saved at http://motreja.com/ankur/webdrill/saved/ankur/${name}.htm\n";
                    } else {
                        print LOG_FILE "Entry{save} = $Entry{\"save\"} and not Yes";
                    }
                    $mail_data = "${mail_data}\n";
                }

            } else {

                print LOG_FILE "ERROR: www_lookup: Unknown match_type $Entry{\"match_type\"}\n";
                $date = `date`;
                print LOG_FILE "$date\n\n";
                $send_log_mail = 1;

            }

            `cp \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\" \"${BASE_CACHE_USER}${name}.htm\"`;
            `rm \"/home/motreja/www/cgi-bin/webdrill/data/temp.htm\"`;
        }
    }

    print LOG_FILE "\nwww_lookup: Calling uninit_get_next_entry\n";
    &uninit_get_next_entry();

    if ($mail_user) {
        $mail_data = "${mail_data}------------------------------\n";
        $mail_data = "${mail_data}\nThis mail is sent as you have subscribed to WebDrill at http://motreja.com/ankur/webdrill/\n";
        $mail_data = "${mail_data}If you feel you have received this mail in error, please send a mail to webdrill\@motreja.com and this account will be immediately disabled.\n\nRegards,\nWebDrill Webmaster";
        $to_mail = $User_data{"MAIL"};
        `echo \"To:$to_mail\nFrom:webdrill\@motreja.com\nSubject:[WebDrill]: match(es) found ...\n$mail_data\" | /usr/sbin/sendmail -t`;

        print LOG_FILE "\nwww_lookup: Mailing to $User_data{\"MAIL\"} :\n";
        print LOG_FILE "\n$mail_data\n";
        print LOG_FILE "END OF MAIL\n\n";
    }

}

print LOG_FILE "\nsend_log_mail = $send_log_mail\n";

close(LOG_FILE);

if ($send_log_mail) {

    open(LOG_FILE, "$log_file");
    open(LOG_MAIL, "| /usr/sbin/sendmail -t");

    print LOG_MAIL "To:webdrill\@motreja.com,ankur_a_m\@yahoo.com\n";
    print LOG_MAIL "From:webdrill\@motreja.com\n";
    print LOG_MAIL "Subject:ERRORs in the log on WebDrill\n";

    while (<LOG_FILE>) {
        print LOG_MAIL "$_\n";
    }

    close(LOG_MAIL);
    close(LOG_FILE);

    open(SMS_ALERT, "| /usr/sbin/sendmail -t");

    print SMS_ALERT "To:ankuram\@my.spicetele.com\n";
    print SMS_ALERT "From:webdrill\@motreja.com\n";
    print SMS_ALERT "Subject:ERRORs logged for WebDrill.";
    print SMS_ALERT "\nCheck mail at webdrill\@motreja.com or ankur_a_m\@yahoo.com\n";

    close(SMS_ALERT);

}

close(LOG_FILE);
print "done";


# Procs start here
# ================


sub init_get_next_entry {
    dbmopen %ENTRIES, "$_[0]", 0666;
    $next_entry_num = 0;
    $largest_entry = $ENTRIES{"LARGEST_KEY"};

    if ($largest_entry eq "") {
        $largest_entry = -1;
    }

}


sub uninit_get_next_entry {

    dbmclose %ENTRIES;

}


sub get_next_entry {

    local ($Next_entry);

    $Next_entry = $_[0];
    $$Next_entry{"valid"} = 0;

    $$Next_entry{"name"} = "asdf";

    if ($next_entry_num > $largest_entry) {
        return 0;
    }

    while ($ENTRIES{"${next_entry_num}_USED"} != 1) {
        $next_entry_num++;
        if ($next_entry_num > $largest_entry) {
            return 0;
        }
    }

    $$Next_entry{"name"} = $ENTRIES{"${next_entry_num}_name"};
    $$Next_entry{"url"} = $ENTRIES{"${next_entry_num}_url"};
    $$Next_entry{"match_type"} = $ENTRIES{"${next_entry_num}_match_type"};
    $$Next_entry{"phrase"} = $ENTRIES{"${next_entry_num}_phrase"};
    $$Next_entry{"save"} = $ENTRIES{"${next_entry_num}_save"};
    $$Next_entry{"valid"} = 1;

    $next_entry_num++;

    return 1;

}


sub get_user_names {

    local ($i, $uname, $line, $users);

    $users = $_[1];

    if (!open (USER_FILE, "$_[0]")) {
      print LOG_FILE "ERROR: www_lookup: get_user_names: Unable to find $_[0]\n";
      $date = `date`;
      print LOG_FILE "$date\n\n";
      $send_log_mail = 1;
      return 0;
    }

    $i = 0;

    while (<USER_FILE>) {
        $line=$_;
        chop ($line);

        if ( ($line !~ /^#/) && ($line ne "") ) {
            ($uname) = split (/:/, $line);
            $$users[$i] = $uname;
            $i++;
        }
    }

    close(USER_FILE);
    return 1;

}


sub get_page {

    local ($url, $file, $ua, $date);

    $url = $_[0];
    $file = $_[1];

    print LOG_FILE "www_lookup: get_page: url = $url, file = $file\n";
    print "Fetching $url ... ";

#    $ua = new LWP::UserAgent;
    $ua = LWP::RobotUA->new( 'WebDrill/1.0', 'ankur@motreja.com' );

    $req = HTTP::Request->new("GET","$url");
    $res = $ua->request($req, "$file");

    $date = `date`;

    if (!$res->is_success) {
        print "unsuccessful<BR>";
        print LOG_FILE "\nERROR: www_lookup: get_page: Problem with get $url. res->status_line: " . $res->status_line . "\n";
        print LOG_FILE "$date\n\n";
        $send_log_mail = 1;
        return 0;
    }

    print "successful<BR>";
    print LOG_FILE "www_lookup: get_page: url = $url, fetch was successful\n";
    print LOG_FILE "$date\n";

    return 1;

}


sub parse_file {

    local ($config_line, $Name, $Value, $Config, $date);

    $Config = $_[1];

    if (!open (CONFIG, "$_[0]")) {
      print LOG_FILE "ERROR: www_lookup: parse_file: User info file $_[0] not found\n";
      $date = `date`;
      print LOG_FILE "$date\n\n";
      $send_log_mail = 1;
    }

    while (<CONFIG>) {
        $config_line=$_;
        chop ($config_line);
        $config_line =~ s/^\s*//;
        $config_line =~ s/\s*$//;
        if ( ($config_line !~ /^#/) && ($config_line ne "") ){
            ($Name, $Value) = split (/=/, $config_line);
            $$Config{$Name} = $Value;
        }
    }

    close(CONFIG);

}

